# 🐍 basilisp 🐍

A Clojure-compatible(-ish) Lisp dialect targeting Python 3.8+.

[![PyPI](https://img.shields.io/pypi/v/basilisp.svg?style=flat-square)](https://pypi.org/project/basilisp/) [![python](https://img.shields.io/pypi/pyversions/basilisp.svg?style=flat-square)](https://pypi.org/project/basilisp/) [![pyimpl](https://img.shields.io/pypi/implementation/basilisp.svg?style=flat-square)](https://pypi.org/project/basilisp/) [![readthedocs](https://img.shields.io/readthedocs/basilisp.svg?style=flat-square)](https://basilisp.readthedocs.io/) [![CircleCI](	https://img.shields.io/circleci/project/github/basilisp-lang/basilisp/master.svg?style=flat-square)](https://circleci.com/gh/basilisp-lang/basilisp) [![Run tests](https://github.com/basilisp-lang/basilisp/actions/workflows/run-tests.yml/badge.svg?branch=main)](https://github.com/basilisp-lang/basilisp/actions/workflows/run-tests.yml) [![Coveralls github](https://img.shields.io/coveralls/github/basilisp-lang/basilisp.svg?style=flat-square)](https://coveralls.io/github/basilisp-lang/basilisp) [![license](https://img.shields.io/github/license/basilisp-lang/basilisp.svg?style=flat-square)](https://github.com/basilisp-lang/basilisp/blob/master/LICENSE)

## Getting Started

Basilisp is developed on [GitHub](https://github.com/basilisp-lang/basilisp) and
hosted on [PyPI](https://pypi.python.org/pypi/basilisp). You can fetch Basilisp
using `pip`:

```bash
pip install basilisp
```

Once Basilisp is installed, you can enter into the REPL using:

```bash
basilisp repl
```

Basilisp [documentation](https://basilisp.readthedocs.io) can help guide your
exploration at the REPL. Additionally, Basilisp features many of the same functions
and idioms as [Clojure](https://clojure.org/), so you may find guides and
documentation there helpful for getting started.

## Why does this project exist?

Basilisp is a project I (@chrisrink10) created to learn about Python, Clojure,
hosted  languages, and compilers.

That said, it is generally stable at this point with reasonably high test
coverage, linting, and type checking. Work is ongoing to complete the rest of
standard the library implementations. I suspect it could be used to build small
applications and tools at this point, though I would not recommend it unless you
like being a very early adopter.

_Use in a production setting at your own risk._

## License

Eclipse Public License 1.0
